package de.tools400.jako2009.webservice.datatypes.test;

import java.math.BigDecimal;
import java.text.DateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;

import de.tools400.jako2009.webservice.datatypes.server.DataTypesRequest;
import de.tools400.jako2009.webservice.datatypes.server.DataTypesResponse;
import de.tools400.jako2009.webservice.datatypes.server.DataTypesService;
import de.tools400.jako2009.webservice.utils.IsoDateTimeUtil;


public class TestDataTypes {

	/**
	 * Prft nur, ob der Aufruf der Stored Procedure funktioniert.
	 * Prft nicht, ob der Web Service funktioniert.
	 */
	public static void main(String[] args) {
		
		DataTypesService aService = new DataTypesService();
		
		DataTypesRequest aRequest = new DataTypesRequest();

	    Calendar timestamp = GregorianCalendar.getInstance();
		
		aRequest.setBool(true);
		aRequest.setSmallInteger(Short.MAX_VALUE);
		aRequest.setInteger(Integer.MAX_VALUE);
		aRequest.setBigInteger(Long.MAX_VALUE);
		aRequest.setSingleFloat(Float.MAX_VALUE);
		aRequest.setDoubleFloat(Double.MAX_VALUE);
		aRequest.setPacked(new BigDecimal("1234567.89"));
		aRequest.setZoned(new BigDecimal("1234.567"));
		aRequest.setString("Testing Data Types");
	    aRequest.setDate(IsoDateTimeUtil.formatDate(timestamp.getTime()));
	    aRequest.setTime(DateFormat.getTimeInstance().format(timestamp.getTime()));
	    aRequest.setTimestamp(timestamp);

		
		DataTypesResponse aResponse = aService.echo(aRequest);
		
		System.out.println("boolean   : " + aResponse.getBool());
		System.out.println("small     : " + aResponse.getSmallInteger());
		System.out.println("integer   : " + aResponse.getInteger());
		System.out.println("bigInt    : " + aResponse.getBigInteger());
		System.out.println("float     : " + aResponse.getSingleFloat());
		System.out.println("double    : " + aResponse.getDoubleFloat());
		System.out.println("packed    : " + aResponse.getPacked());
		System.out.println("zoned     : " + aResponse.getZoned());
		System.out.println("string    : " + aResponse.getString());
		System.out.println("date      : " + aResponse.getDate());
		System.out.println("time      : " + aResponse.getTime());
		System.out.println("timestamp : " + DateFormat.getDateTimeInstance().format(aResponse.getTimestamp().getTime()));
		
	}

}
