package de.tools400.jako2009.webservice.utils;

import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author UADE906585
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class IsoDateTimeUtil {

  private static final String ISO_TIMESTAMP_DATE_TIME = "yyyy-MM-dd-HH.mm.ss.";
  private static final String ISO_TIMESTAMP_MICROSECONDS = "000000";
  
  private static final String ISO_TIME_FORMAT = "HH:mm:ss";
  private static final String ISO_DATE_FORMAT = "yyyy-MM-dd";
  private static final String ISO_TIMESTAMP_FORMAT = ISO_TIMESTAMP_DATE_TIME + ISO_TIMESTAMP_MICROSECONDS; 

  public static Date parseDate(String anIsodate) throws ParseException {
    SimpleDateFormat isoFormat = new SimpleDateFormat(ISO_DATE_FORMAT);
    Date aDate = isoFormat.parse(anIsodate);
    return aDate;
  }
  
  public static Date parseTime(String anIsoTime) throws ParseException {
    SimpleDateFormat isoFormat = new SimpleDateFormat(ISO_TIME_FORMAT);
    Date aDate = isoFormat.parse(anIsoTime);
    return aDate;
  }
  
  public static Timestamp parseTimestamp(String anIsoTimestamp) throws ParseException {
    
    if (anIsoTimestamp.length() < ISO_TIMESTAMP_FORMAT.length()) {
      throw new ParseException("Unparseable timestamp: \"" + anIsoTimestamp + "\". Strint to short.", anIsoTimestamp.length() + 1);
    }
    
    SimpleDateFormat isoFormat = new SimpleDateFormat(ISO_TIMESTAMP_DATE_TIME);
    Date aDate = isoFormat.parse(anIsoTimestamp.substring(0, 20));
    int nanos = Integer.parseInt(anIsoTimestamp.substring(20));
    
    Timestamp timestamp = new Timestamp(aDate.getTime());
    timestamp.setNanos(nanos * 1000); 
    return timestamp;
  }

  public static String formatDate(Date aDate) {
    SimpleDateFormat isoFormat = new SimpleDateFormat(ISO_DATE_FORMAT);
    return isoFormat.format(aDate);
  }

  public static String formatTime(Date aDate) {
    SimpleDateFormat isoFormat = new SimpleDateFormat(ISO_TIME_FORMAT);
    return isoFormat.format(aDate);
  }

  public static String formatTimestamp(Timestamp aTimestamp) {
    SimpleDateFormat isoFormat = new SimpleDateFormat(ISO_TIMESTAMP_DATE_TIME);
    String tmpTimestamp = isoFormat.format(aTimestamp);
    StringBuffer microSeconds =  new StringBuffer(Integer.toString(aTimestamp.getNanos() / 1000));
    if (microSeconds.length() < ISO_TIMESTAMP_MICROSECONDS.length()) {
      microSeconds.insert(0, ISO_TIMESTAMP_MICROSECONDS.substring(0, ISO_TIMESTAMP_MICROSECONDS.length() - microSeconds.length()));
    }
    if (microSeconds.length() > 6) {
      microSeconds.delete(6, microSeconds.length());
    }
    return tmpTimestamp + microSeconds;
  }

  public static String formatTimestamp(Date aDate) {
    Timestamp tmpTimestamp = new Timestamp(aDate.getTime());
    return formatTimestamp(tmpTimestamp);
  }
  
}
