package de.tools400.jako2009.webservice.utils;

import java.io.IOException;
import java.util.ResourceBundle;

public class WebServiceConfiguration {

	private static final String PROPERTY_FILE_NAME = "configuration";
	private static final String PROPERTY_HOSTNAME = "hostname";
	private static final String PROPERTY_USERNAME = "username";
	private static final String PROPERTY_PASSWORD = "password";

	private static WebServiceConfiguration theWebServiceConfiguration = null;
	
	private ResourceBundle theProperties;

	/**
	 * Default-Konstruktor, der nicht auerhalb dieser Klasse
	 * aufgerufen werden kann
	 * @throws IOException 
	 */
	private WebServiceConfiguration() {
		try {
			theProperties = ResourceBundle.getBundle(PROPERTY_FILE_NAME);
		} catch (Exception e) {
			System.out.println("Die Datei 'configuration.properties' konnte nicht gefunden werden.");
			System.out.println("Bitte fhren Sie zunchst die Datei 'build.xml' im Ordner 'build' als ANT Build aus.");
			throw new RuntimeException("Die Datei 'configuration.properties' konnte nicht gefunden werden.", e);
		}
	}

	/**
	 * Statische Methode, liefert die einzige Instanz dieser
	 * Klasse zurck
	 */
	public static WebServiceConfiguration theWebServiceConfiguration() {
		if (theWebServiceConfiguration == null) {
			theWebServiceConfiguration = new WebServiceConfiguration();
		}
		return theWebServiceConfiguration;
	}

	public String hostname() {
		String tmpHostname = theProperties.getString(PROPERTY_HOSTNAME);
		if ("your.host.com".equalsIgnoreCase(tmpHostname)) {
			System.out.println("Die Verbindungsdaten in der Datei '" + PROPERTY_FILE_NAME + ".properties' sind nicht gepflegt!");
			System.out.println("Aktuelle Werte:");
			System.out.println("   Host    : " + tmpHostname);
			System.out.println("   Benutzer: " + username());
			System.out.println("   Passwort: " + password());
			System.out.println("ffnen Sie die Datei 'configuration.properties' im Verzeichnis 'build' und passen Sie die Werte fr den Host, den Benutzer und das Passwort an.");
			System.out.println("Fhren Sie dann die Datei 'build.xml' im Ordner 'build' als ANT Build aus:");
			System.out.println("   Rechts-Click auf 'build.xml' -> Run as -> Ant Build");
			throw new RuntimeException("Verbindungsdaten in Klasse '" + this.getClass().getName() + "' sind nicht gepflegt!");
		}
		return tmpHostname;
	}
	
	public String username() {
		return theProperties.getString(PROPERTY_USERNAME);
	}

	public String password() {
		return theProperties.getString(PROPERTY_PASSWORD);
	}

}
